/*
 *   Copyright 2011-2012 Giuseppe Calà <gcala@mail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef BROWSEFIREFOXBOOKMARKSRUNNER_H
#define BROWSEFIREFOXBOOKMARKSRUNNER_H

#include <plasma/abstractrunner.h>

#include <KIcon>
#include <QDir>

#include <QSqlDatabase>

#define CONNECTIONNAME "BrowseFirefoxBookmarksRunner"

static QSqlDatabase connection_;

class BrowseFirefoxBookmarksRunner : public Plasma::AbstractRunner
{
    Q_OBJECT

public:
    BrowseFirefoxBookmarksRunner(QObject *parent, const QVariantList& args);
    ~BrowseFirefoxBookmarksRunner();

    void match(Plasma::RunnerContext &context);
    void run(const Plasma::RunnerContext &context, const Plasma::QueryMatch &match);

    void reloadConfiguration();

private:
	bool selectDefaultProfile();
	bool createConnection();

private slots:
    bool loadBookmarks();

private:
	KIcon m_icon;
	QStringList m_urls;
	QStringList m_names;
	QDir m_profilesPath;
	QString m_profileName;
	QString m_profileFolder;
	QString m_enabledBookmarksFolders;
	QString m_triggerWord;
	bool m_requireTriggerWord;
};

K_EXPORT_PLASMA_RUNNER(browsefirefoxbookmarks, BrowseFirefoxBookmarksRunner)

#endif
