/*
 *   Copyright 2011-2012 Giuseppe Calà <gcala@mail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef BROWSEFIREFOXBOOKMARKSRUNNERCONFIG_H
#define BROWSEFIREFOXBOOKMARKSRUNNERCONFIG_H

#define CONNECTIONNAME "BrowseFirefoxBookmarksRunnerConfig"

//Project-Includes
#include "ui_browsefirefoxbookmarksrunner_config.h"
//Qt-Includes
//KDE-Includes
#include <KCModule>
#include <QDir>
#include <QSqlDatabase>

static QSqlDatabase connection_;

class BrowseFirefoxBookmarksRunnerConfigForm : public QWidget, public Ui::BrowseFirefoxBookmarksRunnerUI
{
    Q_OBJECT

public:
    explicit BrowseFirefoxBookmarksRunnerConfigForm(QWidget* parent);
};

class BrowseFirefoxBookmarksRunnerConfig : public KCModule
{
    Q_OBJECT

public:
    explicit BrowseFirefoxBookmarksRunnerConfig(QWidget* parent = 0, const QVariantList& args = QVariantList());
	~BrowseFirefoxBookmarksRunnerConfig();

public slots:
    void save();
    void load();
    void defaults();

private:
	struct Profile {
		QString name;
		QString path;
		bool isDefault;
		QString bookmarksFolders;
	};

	QList<Profile> profiles;

    BrowseFirefoxBookmarksRunnerConfigForm* m_ui;
	QDir m_profilesPath;
	QString m_profileName;
	QString m_profileFolder;
	QString m_enabledBookmarksFolders;

	void loadProfiles();
	bool createConnection();
	void populateFoldersListWidget();
	QString getFolderName(const QString &);

private slots:
	void selectProfilesFolder();
	void profileSelected();
	void bookmarksFolderSelected();
	void toggleTriggerWord(int );
};

#endif // BROWSEFIREFOXBOOKMARKSRUNNERCONFIG_H
